package Mastermind;

import java.io.*;

class UI {
    Engine engine;

    public UI() {
        engine = new Engine();
    }

    String input() {
        try {
            BufferedReader m_reader = new BufferedReader(new InputStreamReader(
                    System.in));
            return m_reader.readLine();
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
        return "";
    }

    void newGame() {
        String in;
        engine.newGame();

        System.out.println("\nNeues Spiel\n");

        while (true) {
            System.out.print("Eingabe (mit x beenden): ");
            in = input();
            if (in == null) continue;

            if (in.length() != 4 && !in.equals("x")) {
                System.out.println("Falsche Eingabe!\n");
                continue;
            }
            else {
                if (in.equals("x")) return;
                try {
                    byte[] todo = {Byte.parseByte(in.substring(0, 1)),
                                  Byte.parseByte(in.substring(1, 2)),
                                  Byte.parseByte(in.substring(2, 3)),
                                  Byte.parseByte(in.substring(3, 4))};

                    byte[] ret = engine.check(todo);
                    if (ret[0] == 4) {
                        System.out.println("Die Lsung ist richtig!");
                        System.out.println("Sie haben " + ret[2] +
                                           " Versuche bentigt.\n\n");
                        System.out.println("Neues Spiel\n");
                    } else {
                        System.out.println("Schwarz: " + ret[0] + " Weiss: " +
                                           ret[1] + " Versuch:" + ret[2] + "\n");
                    }
                }
                catch (NumberFormatException nfe) {
                    System.out.println("Falsche Eingabe!\n");
                    continue;
                }
            }
        }
   }




    public static void main(String args[]) {
        UI ui = new UI();
        ui.newGame();



/*        String in;
        while (true) {
            System.out.println("Mastermind - Hauptmenue\n");
            System.out.println("1. Neues Spiel");
            System.out.println("2. Exit");
            System.out.print("\nBitte whlen: ");
            in = ui.input();
            System.out.println();
            if (in == null) continue;

            if (in.equals("1")) ui.newGame();
            if (in.equals("2")) return;
        }
*/    }
}
