/**
 * Copyright (c) 2000 GEMPLUS group. All Rights Reserved.
 *------------------------------------------------------------------------------
 *  Project name    :  GemXpresso RAD III  Environment
 *                      - Java Card applet -
 *
 *  Platform        :  Java virtual machine
 *  Language        :  1.3.0-C
 *  Devl tool       :  Borland (c) JBuilder 5.0 and 6.0
 *
 *  Original author : Author
 *  Date            : Wed May 11 14:25:29 CEST 2005
 *------------------------------------------------------------------------------
 */

/*
 * Package name
 */
package UA;

/*
 * Imported packages
 */
// specific import for Javacard API access
import javacard.framework.*;

public class UAApplet extends javacard.framework.Applet
{

    public static final short ERR_OVERFLOW = 0x6600;
    public static final short ERR_UNDERFLOW = 0x6601;
    public static final short ERR_DIVISION = 0x6602;
    public static final short ERR_OP_NOT_SUPPORTED = 0x660A;
    public static final byte INS_DOIT = (byte)0x02;
    private short [] check = {(short)0x0000, (short)0x8000, (short)0xC000, (short)0xE000,
                             (short)0xF000, (short)0xF800, (short)0xFC00, (short)0xFE00,
                             (short)0xFF00, (short)0xFF80, (short)0xFFC0, (short)0xFFE0,
                             (short)0xFFF0, (short)0xFFF8, (short)0xFFFC, (short)0xFFFE};




    /**
     * UAApplet default constructor
     * Only this class's install method should create the applet object.
     */
    protected UAApplet(byte[] buffer, short offset, byte length)
    {
        // data offset is used for application specific parameter.
        // initialization with default offset (AID offset).
        short dataOffset = offset;
        boolean isOP2 = false;

        if(length > 9) {
            // Install parameter detail. Compliant with OP 2.0.1.

            // | size | content
            // |------|---------------------------
            // |  1   | [AID_Length]
            // | 5-16 | [AID_Bytes]
            // |  1   | [Privilege_Length]
            // | 1-n  | [Privilege_Bytes] (normally 1Byte)
            // |  1   | [Application_Proprietary_Length]
            // | 0-m  | [Application_Proprietary_Bytes]

            // shift to privilege offset
            dataOffset += (short)( 1 + buffer[offset]);
            // finally shift to Application specific offset
            dataOffset += (short)( 1 + buffer[dataOffset]);

           // <IF NECESSARY, USE COMMENTS TO CHECK LENGTH >
           // // checks wrong data length
           // if(buffer[dataOffset] !=  <PUT YOUR PARAMETERS LENGTH> )
           //     // return received proprietary data length in the reason
           //     ISOException.throwIt((short)(ISO7816.SW_WRONG_LENGTH + offset + length - dataOffset));

            // go to proprietary data
            dataOffset++;

            // update flag
            isOP2 = true;

        } else {
           // <IF NECESSARY, USE COMMENTS TO CHECK LENGTH >
           // if(length != <PUT YOUR PARAMETERS LENGTH> )
           //     ISOException.throwIt((short)(ISO7816.SW_WRONG_LENGTH + length));
       }

        // <PUT YOUR CREATION ACTION HERE>

        // register this instance
        if (isOP2)
          register(buffer, (short)(offset + 1), (byte)buffer[offset]);
        else
          register();
    }

    /**
     * Method installing the applet.
     * @param bArray the array constaining installation parameters
     * @param bOffset the starting offset in bArray
     * @param bLength the length in bytes of the data parameter in bArray
     */
    public static void install(byte[] bArray, short bOffset, byte bLength) throws ISOException
    {
        /* applet  instance creation */
        new UAApplet (bArray, bOffset, (byte)bLength );
    }

    /**
     * Select method returns true if applet selection is supported.
     * @return boolean status of selection.
     */
    public boolean select()
    {
        // <PUT YOUR SELECTION ACTION HERE>

        // return status of selection
        return true;
    }

    /**
     * Deselect method called by the system in the deselection process.
     */
    public void deselect()
    {

        // <PUT YOUR DESELECTION ACTION HERE>

        return;
    }

    /**
     * Method processing an incoming APDU.
     * @see APDU
     * @param apdu the incoming APDU
     * @exception ISOException with the response bytes defined by ISO 7816-4
     */
    public void process(APDU apdu) throws ISOException
    {
        // get the APDU buffer
        byte[] apduBuffer = apdu.getBuffer();

        // ignore the applet select command dispached to the process
        if (selectingApplet())
            return;

        // APDU instruction parser
        switch ( apduBuffer[ISO7816.OFFSET_INS] )
        {
            case INS_DOIT: doIt(apdu); return;
            default :
                // The INS code is not supported by the dispatcher
                ISOException.throwIt( ISO7816.SW_INS_NOT_SUPPORTED ) ;
            break ;

        }
    }

    private void doIt(APDU apdu) throws ISOException {
        short len = apdu.setIncomingAndReceive();
        if (len != 5) ISOException.throwIt(ISO7816.SW_WRONG_LENGTH);
        byte[] buffer = apdu.getBuffer();

        short x = Util.getShort(buffer, ISO7816.OFFSET_CDATA);
        short y = Util.getShort(buffer, (short) (ISO7816.OFFSET_CDATA + 2));
        byte instr = buffer[ISO7816.OFFSET_CDATA + 4];
        short tmpX = 0;
        short tmpY = 0;
        short erg = 0;

        switch (instr) {
        case 0: // <
            erg = isLower(x, y);
            break;
        case 1: // +
            erg = add(x, y);
            break;
        case 2: // -
            if ((x & (short)0x8000) == (y & (short)0x8000) && (x & 0x7FFF) < (y & 0x7FFF)) ISOException.throwIt(ERR_UNDERFLOW);
            if ((x & (short)0x8000) == 0 && (y & (short)0x8000) != 0) ISOException.throwIt(ERR_UNDERFLOW);
            erg = (short) (x - y); break;
        case 3: // *
            erg = 0;
            for (byte i = 15; i >= 0; i--) {
                if ((y & (short)(1 << i)) != 0) {
                    if ((x & check[i]) != 0) {
                        ISOException.throwIt(ERR_OVERFLOW);
                    }
                    else {
                        erg = add(erg, (short) (x << i));
                    }
                }
            }
            break;
        case 4: // /  - aufgeteilt in 4 Flle, je nach Vorz. von x und y
            if (y == 0) ISOException.throwIt(ERR_DIVISION);
            if (x == 0) { erg = 0; break; }//speed...!
            if (y == 1) { erg = x; break; }
            if (x == y) { erg = 1; break; }
            if (isLower(x,y) == 1) { erg = 0; break; } //x<y (beinhaltet: x nicht-negativ, y negativ)
            // x,y nicht-negativ
            if (((x | y) & (short)0x8000) == 0) { erg = (short) (x / y); break; }
            // x,y negativ
            if ((x & y & (short)0x8000) != 0)  {
                if ((short)((x & 0x7FFF) - (y & 0x7FFF)) >= 0) { erg = 1; break; } //x > y
                erg = 0; break; //y > x
            }
            // x negativ, y nicht-negativ
            if ((x & (short)0x8000) != 0 && (y & (short)0x8000) == 0) {
                tmpX = (short) ((x & 0x7FFF) / y);
                tmpY = (short) (0x7FFF / y);
                x = (short) ((x & 0x7FFF) - tmpX * y); //Rest der Div vom Rest von x
                x += (short) (0x7FFF - tmpY * y + 1); //Rest der Div bis 0x8000
                erg = (short) (tmpX + tmpY + (short)(x / y));
                break;
            }
      case 5: // Spezialflle
            if (y == 0) ISOException.throwIt(ERR_DIVISION);
            if (x == 0) { erg = 0; break; } //geht schneller...
            if (y == 1) { erg = 0; break; } // -"-
            if (x == y) { erg = 0; break; } // -"-
            if (isLower(x,y) == 1) { erg = x; break; } //x < y (beinhaltet: x nicht-negativ, y negativ)
            // x,y nicht-neagtiv
            if (((x | y) & (short)0x8000) == 0) {
                tmpX = (short) (x / y);
                erg = (short) (x - (short) (tmpX * y));
                break;
            }
            // x,y neagtiv
            if ((short) (x & y & (short)0x8000) != 0) {
               erg = (short) ((short) (x & 0x7FFF) - (short) (y & 0x7FFF));
               break;
            }
            // x negativ, y nicht-negativ
            tmpX = (short) ((x & 0x7FFF) / y);
            tmpY = (short) (0x7FFF / y);
            x = (short) ((short)(x & 0x7FFF) - (short)(tmpX * y)); //Rest der Div vom Rest von x
            x += (short) (0x7FFF - (short)(tmpY * y) + 1); //Rest der Div bis 0x8000
            if (y <= x) erg = (short) (x-y);
            else erg = (short) (x);
            break;


          default: ISOException.throwIt(ERR_OP_NOT_SUPPORTED);
          }
        Util.setShort(buffer, ISO7816.OFFSET_CDATA, erg);
        apdu.setOutgoing();
        apdu.setOutgoingLength((short) 2);
        apdu.sendBytes(ISO7816.OFFSET_CDATA, (short) 2);
    }

    private short isLower (short x, short y) {
        if ( (x & (short)0x8000) == 0 && (y & (short)0x8000) != 0 ) return 1;
        if ( (x & (short)0x8000) != 0 && (y & (short)0x8000) == 0 ) return 0;
        if ( (x & 0x7FFF) < (y & 0x7FFF) ) return 1;
	return 0;
    }

    private short add(short x, short y) throws ISOException {
        short tmpX;
        tmpX = (short) ((x & 0x7FFF) + (y & 0x7FFF));
        if ((short) (x & y & (short)0x8000) != 0) ISOException.throwIt(ERR_OVERFLOW);
        if ((short) (((x & (short)0x8000) | (y & (short)0x8000)) & (tmpX & (short)0x8000)) < 0) ISOException.throwIt(ERR_OVERFLOW);
        return (short) (x + y);
    }



}

