package CopyCard;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import com.borland.jbcl.layout.XYLayout;
import com.borland.jbcl.layout.*;


/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class CCTerminal extends JFrame implements ActionListener {

    Engine engine = new Engine();

    JMenuBar jMenuBarMainMenu = new JMenuBar();
    JMenu jMenuFile = new JMenu();
    JMenuItem jMenuItemExit = new JMenuItem();
    JButton jButtonGetBalance = new JButton();
    JLabel jLabelCredits = new JLabel();
    JButton jButtonLoad = new JButton();
    JTextField jTextFieldCredits = new JTextField();
    JButton jButtonPay = new JButton();
    XYLayout xYLayout = new XYLayout();

    public CCTerminal() {
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        this.getContentPane().setLayout(xYLayout);
        this.setJMenuBar(jMenuBarMainMenu);
        jMenuFile.setText("File");
        jMenuItemExit.setText("Exit");
        jMenuItemExit.setActionCommand("Exit");
        jMenuItemExit.addActionListener(this);
        jButtonGetBalance.setText("GetCredits");
        jButtonGetBalance.addActionListener(this);
        jLabelCredits.setText("Credits:");
        jButtonLoad.setActionCommand("Load");
        jButtonLoad.setText("Load");
        jButtonLoad.addActionListener(this);
        jTextFieldCredits.setText("");
        jButtonPay.setActionCommand("Pay");
        jButtonPay.setText("Pay");
        jButtonPay.addActionListener(this);
        jMenuBarMainMenu.add(jMenuFile);
        jMenuFile.add(jMenuItemExit);
        this.getContentPane().add(jButtonGetBalance,
                                  new XYConstraints(10, 10, 100, 24));
        this.getContentPane().add(jLabelCredits,
                                  new XYConstraints(120, 10, 120, 24));
        this.getContentPane().add(jButtonLoad,
                                  new XYConstraints(10, 40, 70, 24));
        this.getContentPane().add(jTextFieldCredits,
                                  new XYConstraints(90, 40, 70, -1));
        this.getContentPane().add(jButtonPay,
                                  new XYConstraints(170, 40, 70, 24));

        this.pack();
    }

    public void dispose() {
        super.dispose();
        engine.dispose();
    }


    public void actionPerformed(ActionEvent e) {
        try {
            if (e.getActionCommand().equals("Exit")) {
                dispose();
            }
            if (e.getActionCommand().equals("GetCredits")) {
                jLabelCredits.setText("" + engine.balance());
            }
            if (e.getActionCommand().equals("Load")) {
                int credits = getInput();
                if (credits == -1) return;
                jLabelCredits.setText("" + engine.load(credits));
            }
            if (e.getActionCommand().equals("Pay")) {
                int credits = getInput();
                if (credits == -1) return;
                jLabelCredits.setText("" + engine.pay(credits));
            }
        } catch (OverLimitException ex) {
            JOptionPane jop = new JOptionPane();
            jop.showMessageDialog(this,
                                  "Das Kartenlimit wurde berschritten!",
                                  "Warnung!",
                                  JOptionPane.OK_OPTION);
        } catch (LowCreditException ex) {
            JOptionPane jop = new JOptionPane();
            jop.showMessageDialog(this,
                                  "Zu wenig credits!",
                                  "Warnung!",
                                  JOptionPane.OK_OPTION);
        } catch (WrongNonceException ex) {
            JOptionPane jop = new JOptionPane();
            jop.showMessageDialog(this,
                                  "Nonce fehlerhaft!\nProgramm wird beendet.",
                                  "Warnung!",
                                  JOptionPane.OK_OPTION);
        } catch (AuthFailedException ex) {
            JOptionPane jop = new JOptionPane();
            jop.showMessageDialog(this,
                                  "Authentifizierung fehlgeschlagen!\nProgramm wird beendet.",
                                  "Warnung!",
                                  JOptionPane.OK_OPTION);
            dispose();

        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private int getInput() {
        int tmp = -1;
        try {
            tmp = Integer.parseInt(jTextFieldCredits.getText());
            if (tmp < 0) {
                JOptionPane jop = new JOptionPane();
                jop.showMessageDialog(this,
                                      "Bitte eine positive Zahl eingeben!",
                                      "Warnung!",
                                      JOptionPane.OK_OPTION);
                tmp = -1;
            }
            if (tmp > 50000) {
                JOptionPane jop = new JOptionPane();
                jop.showMessageDialog(this,
                                      "Bitte eine Zahl kleiner 50000 eingeben!",
                                      "Warnung!",
                                      JOptionPane.OK_OPTION);
                tmp = -1;
            }

        } catch (NumberFormatException ex) {
            JOptionPane jop = new JOptionPane();
            jop.showMessageDialog(this,
                                  "Bitte eine Zahl eingeben!",
                                  "Warnung!",
                                  JOptionPane.OK_OPTION);
            return -1;
        }
        return tmp;
    }

    public static void main(String[] args) throws AuthFailedException {
        CCTerminal terminal = new CCTerminal();
        terminal.setVisible(true);
    }
}
