package CopyCard;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import com.borland.jbcl.layout.XYLayout;
import com.borland.jbcl.layout.*;


/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.2
 */
public class CCTerminal extends JFrame implements ActionListener {
    Engine engine = new Engine();

    JButton jButtonGetBalance = new JButton();
    JLabel jLabelCreditsLabel = new JLabel("Credits:", SwingConstants.CENTER);
    JLabel jLabelCredits = new JLabel("", SwingConstants.RIGHT);
    JButton jButtonLoad = new JButton();
    JTextField jTextFieldCredits = new JTextField();
    JButton jButtonPay = new JButton();
    XYLayout xYLayout = new XYLayout();

    public CCTerminal() {
        super("CopyCard Terminal");
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        UIManager.setLookAndFeel(
                "com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
        //UIManager.setLookAndFeel("com.sun.java.swing.plaf.gtk.GTKLookAndFeel");
        this.getContentPane().setLayout(xYLayout);

        jButtonGetBalance.setText("GetCredits");
        jButtonGetBalance.addActionListener(this);
        jButtonLoad.setActionCommand("Load");
        jButtonLoad.setText("Load");
        jButtonLoad.addActionListener(this);
        jTextFieldCredits.setText("");
        jButtonPay.setActionCommand("Pay");
        jButtonPay.setText("Pay");
        jButtonPay.addActionListener(this);
        this.setJMenuBar(null);
        this.getContentPane().add(jButtonGetBalance,
                                  new XYConstraints(10, 10, 100, 24));
        this.getContentPane().add(jLabelCreditsLabel,
                                  new XYConstraints(120, 10, 80, 24));
        this.getContentPane().add(jLabelCredits,
                                  new XYConstraints(200, 10, 40, 24));
        this.getContentPane().add(jButtonLoad,
                                  new XYConstraints(10, 40, 70, 24));
        this.getContentPane().add(jTextFieldCredits,
                                  new XYConstraints(90, 40, 70, -1));
        this.getContentPane().add(jButtonPay,
                                  new XYConstraints(170, 40, 70, 24));
        SwingUtilities.updateComponentTreeUI(this);
        this.pack();
        this.setSize(this.getSize().width + 10, this.getSize().height + 10);
        Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
        setLocation((screen.width - getBounds().width) / 2,
                    (screen.height - getBounds().height) / 2);
        setResizable(false);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                dispose(); //System.exit(0);
            }
        });
    }

    private void doAction(byte id) throws Exception {
        int credits = 0;
        while (true) {
            try {
                switch (id) {
                case Engine.INS_BALANCE:
                    jLabelCredits.setText("" + engine.balance());
                    return;
                case Engine.INS_PAY:
                    credits = getInput();
                    if (credits == -1)return;
                    jLabelCredits.setText("" + engine.pay(credits));
                    return;
                case Engine.INS_LOAD:
                    credits = getInput();
                    if (credits == -1)return;
                    jLabelCredits.setText("" + engine.load(credits));
                    return;
                }
            } catch (swt.swtTerminalException ex) {
                JOptionPane m = new JOptionPane();
                int option = m.showConfirmDialog(this,
                                                 "Karte nicht gefunden! Nochmal versuchen?",
                                                 "CopyCard Terminal",
                                                 JOptionPane.ERROR_MESSAGE,
                                                 JOptionPane.OK_CANCEL_OPTION);

                if (option == JOptionPane.YES_OPTION) {
                    engine.connect();

                    continue;
                } else {
                    dispose();
                    return;
                }
            }
        }
    }

    public void actionPerformed(ActionEvent e) {
        try {
            if (e.getActionCommand().equals("Exit")) {
                dispose();
            }
            if (e.getActionCommand().equals("GetCredits")) {
                doAction(Engine.INS_BALANCE);
            }
            if (e.getActionCommand().equals("Load")) {
                doAction(Engine.INS_LOAD);
            }
            if (e.getActionCommand().equals("Pay")) {
                doAction(Engine.INS_PAY);
            }
        } catch (OverLimitException ex) {
            JOptionPane jop = new JOptionPane();
            jop.showMessageDialog(this,
                                  "Das Kartenlimit wurde berschritten!",
                                  "Warnung!",
                                  JOptionPane.OK_OPTION);
        } catch (LowCreditException ex) {
            JOptionPane jop = new JOptionPane();
            jop.showMessageDialog(this,
                                  "Sie haben nicht genug Credits!",
                                  "Warnung!",
                                  JOptionPane.OK_OPTION);
        } catch (WrongNonceException ex) {
            JOptionPane jop = new JOptionPane();
            jop.showMessageDialog(this,
                                  "Nonce fehlerhaft!\nProgramm wird beendet.",
                                  "Warnung!",
                                  JOptionPane.OK_OPTION);
            dispose();
        } catch (AuthFailedException ex) {
            JOptionPane jop = new JOptionPane();
            jop.showMessageDialog(this,
                                  "Authentifizierung fehlgeschlagen!\nProgramm wird beendet.",
                                  "Warnung!",
                                  JOptionPane.OK_OPTION);
            dispose();

        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private int getInput() {
        int tmp = -1;
        try {
            tmp = Integer.parseInt(jTextFieldCredits.getText());
            if (tmp < 0) {
                JOptionPane jop = new JOptionPane();
                jop.showMessageDialog(this,
                                      "Bitte eine positive Zahl eingeben!",
                                      "Warnung!",
                                      JOptionPane.OK_OPTION);
                tmp = -1;
            }
            if (tmp > 50000) {
                JOptionPane jop = new JOptionPane();
                jop.showMessageDialog(this,
                                      "Bitte eine Zahl kleiner 50000 eingeben!",
                                      "Warnung!",
                                      JOptionPane.OK_OPTION);
                tmp = -1;
            }

        } catch (NumberFormatException ex) {
            JOptionPane jop = new JOptionPane();
            jop.showMessageDialog(this,
                                  "Bitte eine Zahl eingeben!",
                                  "Warnung!",
                                  JOptionPane.OK_OPTION);
            return -1;
        }
        return tmp;
    }

    public static void main(String[] args) throws AuthFailedException {
        CCTerminal terminal = new CCTerminal();
        terminal.setVisible(true);
    }
}
